Index: src/framing.c
===================================================================
--- src/framing.c	(revision 16052)
+++ src/framing.c	(working copy)
@@ -386,6 +386,7 @@
   int maxvals=(os->lacing_fill>255?255:os->lacing_fill);
   int bytes=0;
   long acc=0;
+  int thresh=4096;
   ogg_int64_t granule_pos=-1;
 
   if(ogg_stream_check(os)) return 0;
@@ -404,9 +405,23 @@
         break;
       }
     }
-  }else{
+  }else{             /* 'normal page' case */
     for(vals=0;vals<maxvals;vals++){
-      if(acc>4096)break;
+      if(acc>thresh){
+        /* search ahead for the next packet break */
+	int a=0,v;
+	for (v=vals;v<maxvals;v++){
+	  a+=os->lacing_vals[v]&0x0ff;
+	  if((os->lacing_vals[v]&0x0ff)<255){
+	    v++;
+	    break;
+	  }
+	}
+	/* if the packet would make us less than twice our
+	   target size, take it, otherwise split */
+	if(a<thresh)thresh+=a;
+	else break;
+      }
       acc+=os->lacing_vals[vals]&0x0ff;
       if((os->lacing_vals[vals]&0xff)<255)
         granule_pos=os->granule_vals[vals];